' '
from OFS.Folder import Folder

import calendar, Globals,time
import Products.OFSP

class ArchiveBase(Folder):
    """ """
    meta_type = 'ArchiveBase'
    
    __ac_permissions__=(
        ('View', ('todaysDate',)),
        ('Manage properties',('manage_arhive',))
    )
    
    manage_options=(
        {'label':'View', 'action':'index_html'},
        {'label':'Security', 'action':'manage_access'},
        {'label':'Archive','action':'manage_archive'}
    )
  
    def _2_digit_str(self,number):
        return '%02d'%number

    def todaysDate(self):
        """ Print 'date' of object in archive """
        
        return time.strftime('%A, %B '+'%d'%int(self.cached_day) +', %Y',self.cached_date)
        
    def create_day(self,month_folder,day_number,weekday):
        """ """
        day_folder_id=self._2_digit_str(day_number)
        if day_folder_id not in month_folder.objectIds():
            month_folder.manage_addFolder(id=day_folder_id)
        day_folder=month_folder[day_folder_id]
        if not day_folder.title: 
            day_folder.title=calendar.day_abbr[weekday]
        
    def fillMonth(self,month_folder,year,month):
        """put days in month"""
        weekday,num_days=calendar.monthrange(int(year),int(month))
        for day in range(1,num_days+1):
            self.create_day(month_folder,day,weekday)
            weekday=(weekday+1)%7

    def fillYear(self,year,days=None):
        """ put months in year, if days!=None put days in month  """
        for month in range(1,13):
            year_folder=self[year]
            month_folder_id=self._2_digit_str(month)
            if month_folder_id not in year_folder.objectIds(): 
                year_folder.manage_addFolder(id=month_folder_id)
            #year_folder[month_folder_id].title=calendar.month_abbr[month]  //Dont need to update title               
            if days:
                self.fillMonth(year_folder[month_folder_id],year,month)

    def addYear(self,year,months=None,days=None):
        """ """
        if year not in self.objectIds():
            self.manage_addFolder(id=year)
        if months:
            self.fillYear(year,days)
                


    index_html=Globals.HTMLFile("archive_root", globals())
    
    def __str__(self):
        return self.index_html(self, self.REQUEST)
    
    def find_current(self):
        """   """
        now=time.gmtime(time.time())
        current_month=now[1]
        current_day=now[2]
        for year in range(now[0],1999,-1):
            year_string=str(year)
            if year_string in self.objectIds():
                year_folder=self[year_string]
                for month in range(current_month,0,-1):
                    month_string=self._2_digit_str(month)
                    if month_string in year_folder.objectIds():

                        month_folder=year_folder[month_string]
                        for day in range(current_day,0,-1):
                            day_string=self._2_digit_str(day)
                            if day_string in month_folder.objectIds():
                                day_folder=month_folder[day_string]
                                if 'index_html' in day_folder.objectIds():
                                    self.cache_date=now
                                    self.cached_year=year_string
                                    self.cached_month=month_string
                                    self.cached_day=day_string
                                    self.cached_date=time.localtime(time.mktime((year,month,day,0,0,0,0,0,0)))
                                    return day_folder
                        comment="""if 'index_html' in day_folder.objectIds(): #Check if there's a monthly 'index_html'
                            self.cache_date=now
                            self.cached_year=year_string
                            self.cached_month=month_string
                            self.cached_day=None
                            return day_folder"""                  
                    current_day=31
                #end of "for month"
            current_month=12
        #end of "for year"
        self.cache_date=now
        self.cached_year=None
        self.cached_month=None
        self.cached_day=None
        self.cached_date=None
        return None

    def current_page(self):
        """ returns the cached folder or runs find_current to get a new one"""
        try:
            if time.gmtime(time.time())[0:3]==self.cache_date[0:3]:          
                return self[self.cached_year][self.cached_month][self.cached_day]
        except:
            pass
        return self.find_current()

    manage_archive=Globals.HTMLFile("manage_archive", globals())

    def manage_date(self,year,month,day,RESPONSE):
        """ Takes you to the date. creates if necessary. year,month,day are strings """
        #Validate 
        year_number=int(year)
        if year_number<2000:
            raise ValueError, "Year must be 2000 or later."
        month_number=int(month)
        if not 1<=month_number<=12:
            raise ValueError, "Invalid Month Name"
        day_number=int(day)
        if not 1<=day_number<=calendar.monthrange(year_number,month_number):
            raise ValueError, "Invalid date" 

        #get year
        if year not in self.objectIds():
            self.manage_addFolder(id=year)
        year_folder=self[year]
        
        #get month
        month_id=self._2_digit_str(month_number)
        if month_id not in year_folder.objectIds():
            year_folder.manage_addFolder(id=month_id)
        month_folder=year_folder[month_id]
        
        #get day
        self.create_day(month_folder,day_number,calendar.weekday(year_number,month_number,day_number))
        RESPONSE.redirect(year+"/"+month_id+"/"+self._2_digit_str(day_number)+'/manage_main')
        
    def archive_tpValues(self):
        """ """
        return_list=[]
        for item in self.objectItems():
            try:
                id_number=int(item.id)
            except:
                id_number=0
            #year objects:
            if id_number>2000: # integers over 2000 are treated as years
                for month in item.objectItems():
                    appended=0
                    month_id=month.id
                    try:
                        month_number=int(month_id)
                    except:
                        continue #This is not a month.            
                    if len(month_id)!=2 or  not 1<=month_number<=12:
                        continue #This is not a month.
                    for day in month.objectItems():
                        if 'index_html' in day.objectIds():
                            return_list=return_list+[item.id]
                            appended=1
                            break
                    if appended==1:
                        break
        return return_list                
       
                
          
            
            
        
         
        
                
        





